//Steel.cs
datablock AudioProfile(MasterSwordDrawSound)
{
   filename    = "./OOT_Sword_Draw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(MasterSwordSwingSound)
{
   filename    = "./OOT_Sword.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(MasterSwordHitOther1)
{
   filename    = "./OOT_Sword_Rock.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(MasterSwordHitOther2)
{
   filename    = "./OOT_Sword_Rock2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(MasterSwordHitOther3)
{
   filename    = "./OOT_Sword_Rock3.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(MasterSwordHitPlayerSound)
{
   filename    = "./OOT_Sword_Cut.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(MasterSwordExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.8 0.8 0.8 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(MasterSwordExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MasterSwordExplosionParticle";

};

datablock ExplosionData(MasterSwordExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;


   particleEmitter = MasterSwordExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("MasterSword",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(MasterSwordProjectile)
{
   directDamage        = 45;
   directDamageType  = $DamageType::MasterSword;
   radiusDamageType  = $DamageType::MasterSword;
   explosion           = MasterSwordExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0.5 0.5";

};


//////////
// item //
//////////
datablock ItemData(MasterSwordItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./masterSword.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Master Sword";
	iconName = "./mastersword_icon";
	doColorShift = true;
	colorShiftColor = "0.700 0.700 0.700 1.000";

	 // Dynamic properties defined by the scripts
	image = MasterSwordImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MasterSwordImage)
{
   // Basic Item properties
   shapeFile = "./masterSword.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   //eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MasterSwordItem;
   ammo = " ";
   projectile = MasterSwordProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.700 0.700 0.700 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = MasterSwordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateSound[2]                    = MasterSwordSwingSound;
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Wait";

	stateName[5]                    = "Wait";
	stateTransitionOnTimeout[5]	= "PreFire";
	stateTimeoutValue[5]            = 0.4;
	stateWaitForTimeout[5]		= false;
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateScript[5]                  = "onWait";
	stateAllowImageChange[5]        = false;
	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateScript[6]                  = "onStopFire";


};

function MasterSwordImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, shiftdown);
}

function MasterSwordImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function MasterSwordImage::onWait(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function MasterSwordProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	if(%col.getType() & $Typemasks::PlayerObjectType)
	{
		serverplay3d(MasterSwordHitPlayerSound,%pos);	
	}
	else
	{
		%random = getRandom(1,3);
		switch(%random)
		{
			case 1:
				serverplay3d(MasterSwordHitOther1,%pos);
			case 2:
				serverplay3d(MasterSwordHitOther2,%pos);
			case 3:
				serverplay3d(MasterSwordHitOther3,%pos);
			default:
				echo("Error on Master Sword");
		}
	}
}
